# This file can be used to customize tox tests as well as other test frameworks like flake8 and mypy

[tox]
envlist = py38
; envlist = py37, py38, py39
isolated_build = true

[testenv]
whitelist_externals = poetry

commands =
    poetry install -v
    poetry run pytest
    poetry run black --check tap_exact/
    poetry run flake8 tap_exact
    poetry run pydocstyle tap_exact
    poetry run mypy tap_exact --exclude='tap_exact/tests'

[testenv:pytest]
# Run the python tests.
# To execute, run `tox -e pytest`
envlist = py37, py38, py39
commands =
    poetry install -v
    poetry run pytest

[testenv:format]
# Attempt to auto-resolve lint errors before they are raised.
# To execute, run `tox -e format`
commands =
    poetry install -v
    poetry run black tap_exact/
    poetry run isort tap_exact

[testenv:lint]
# Raise an error if lint and style standards are not met.
# To execute, run `tox -e lint`
commands =
    poetry install -v
    poetry run black --check --diff tap_exact/
    poetry run isort --check tap_exact
    poetry run flake8 tap_exact
    poetry run pydocstyle tap_exact
    # refer to mypy.ini for specific settings
    poetry run mypy tap_exact --exclude='tap_exact/tests'

[flake8]
ignore = W503
max-line-length = 88
max-complexity = 10

[pydocstyle]
ignore = D105,D203,D213
